=== debian/changelog ===
zulucrypt (5.2.0-1) unstable; urgency=medium

  * New upstream release.
  * Bumped DH level to 10.
  * debian/control:
      - Bumped Standards-Version to 4.0.0.
      - Updated Build-Depends.
      - Updated file.
  * debian/copyright:
      - Updated file.
  * debian/rules:
      - Removed option --parallel.
      - Disabled the polkit support at build time.
  * Updated the file libzulucrypt1.2.0.symbols.

 -- Marcio de Souza Oliveira <m.desouza20@gmail.com>  Fri, 04 Aug 2017 22:32:16 +0000

zulucrypt (5.1.0-1) experimental; urgency=medium

  * New upstream release.
  * debian/copyright:
      - Updated file.
  * debian/patches:
      - Updated patch fix_spelling.
  * Updated the file libzulucrypt-exe1.2.0.symbols.
  * Updated the files zulu*-gui.install to install icons hicolor.

 -- Marcio de Souza Oliveira <m.desouza20@gmail.com>  Thu, 13 Apr 2017 15:51:50 +0000
